
module grace_prim_asa;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  // output
  dict_addnf("pr"     ,&p_pr     ,[            "asa"],[]);
  dict_addnf("new-asa",&p_new_asa,[                 ],["asa"]);
  dict_addnf("put"    ,&p_put    ,[ "*" ,"str","asa"],["asa"]);
  dict_addnf("get"    ,&p_get    ,[      "str","asa"],[ "*" ]);
}

static this()
{
  reg_prims~=&reg_prim;
}
// --------------------
// ----- display

void p_pr()
{
  cell[char[]] asa=dpop_asa();
  char[][] keys=asa.keys;
  cell[] vals=asa.values;
  writef("[ ");
  for (int k=0;k<keys.length;k++)
    writef(keys[k],"->",cell_vs(vals[k])," ");
  writef("]\n");
}

void p_new_asa()
{
  cell[char[]] asa;
  dpush_asa(asa);
}

void p_put()
{
  cell[char[]] asa=dpop_asa();
  char[] key=dpop_str();
  cell val=dpop();
  asa[key]=val;
  dpush_asa(asa);
}

void p_get()
{
  cell[char[]] asa=dpop_asa();
  char[] key=dpop_str();
  dpush(asa[key]);
}
