
module grace_prim_bar;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  dict_addnf("2chr"       ,&p_int2chr ,["int"],["chr"]);
  dict_addnf("2int"       ,&p_chr2int ,["chr"],["int"]);
  dict_addnf("2str"       ,&p_bar2str ,["bar"],["str"]);
  dict_addnf("2lst"       ,&p_bar2lst ,["bar"],["lst"]);
  dict_addnf("2lst"       ,&p_str2lst ,["str"],["lst"]);
  dict_addnf("2str"       ,&p_sym2str ,["sym"],["str"]);
  dict_addnf("2sym"       ,&p_str2sym ,["str"],["sym"]);
}

static this()
{
  reg_prims~=&reg_prim;
}

void p_sym2str()
{
  dpush_str(dpop_sym().s);
}

void p_str2sym()
{
  char[] s=dpop_str();
  cell c=sym2cell(s,dicthead);
  dpush(c);
}

void p_int2chr()
{
  dpush_chr(dpop_int());
}

void p_chr2int()
{
  dpush_int(dpop_chr());
}

void p_bar2str()
{
  dpush_str(cast(char[])dpop_bar());
}

void p_bar2lst()
{
  void[] b=dpop_bar();
  char  *c=cast(char*)b.ptr;
  denternew();
  for (int k=0;k<b.length;k++)
    dpush_int(cast(int)c[k]);
  dleave();
}

void p_str2lst()
{
  char[] s=dpop_str();
  denternew();
  for (int k=0;k<s.length;k++)
    dpush_int(cast(int)s[k]);
  dleave();
}
