
// --- test dictionary introspection

defun: dpr [dup pr cr]

// get dictionary
dict
//
// while:[dup length 2 >][tail]
// remove non-functions
filter:[1 getat 1 =]
// remove natives
filter:[reverse head type? "nfp" !=]
// add trace headers to non-native functions
map:
[
//  dup pr cr
  enter
  // only lists
  if: [dup type? "lst" =]
  [
    // copy name entry to tos
    xdive soar dup top xsoar
    // add intro code
    dup dive
    "[entering " swap cat "] " cat
    [cr pr] cons swap cat
    // add exit code
    soar
    "[leaving " swap cat "] " cat
    [cr pr] cons cat
  ]
  // .
  leave
]
// set new definitions
each:
[
  split reverse head swap 2sym set
]
