
module grace_def;

public import std.c.stdlib;
public import std.c.string;
public import std.utf;
public import std.conv;
public import std.file;
public import std.stdio;
public import std.boxer;
public import std.format;
public import std.string;
public import std.regexp;

typedef void(*nfun)();

//alias std.string.toStringz asciiz;

char[] swritef(...)  // or call it swritef; this name's from Python
{
  char[] result;

  void putc(dchar c)
  {
    std.utf.encode(result,c);
  }

  std.format.doFormat(&putc, _arguments, _argptr);
  return result;
}

int[char[]] uniHash;
char[][] uniHashReverse;

int str2uh(char[] s)
{
  int *p=(s in uniHash);
  if (p)
  {
//    writef("get uniHash('%s",s,"')->",*p,"\n");
    return *p;
  }
  int r=uniHashReverse.length;
  uniHash[s]=r;
  uniHashReverse~=s;
//  writef("set uniHash('%s",s,"')->",r,"\n");
  return r;
}

char[] uh2str(int h)
{
  return uniHashReverse[h];
}
